<?php
//Activate post-image functionality (WP 2.9+)
if ( function_exists( 'add_theme_support' ) )
add_theme_support( 'post-thumbnails' );

// Get URL of first image in a post
function catch_that_image() {
global $post, $posts;
$first_img = '';
ob_start();
ob_end_clean();
$output = preg_match_all('/<img.+src=[\'"]([^\'"]+)[\'"].*>/i', $post->post_content, $matches);
$first_img = $matches [1] [0];

// no image found display default image instead
if(empty($first_img)){
$first_img = "/images/no-image.jpg";
}
return $first_img;
}

// Enable Custom Background
add_custom_background();

//Include Comments Template
include('functions/comments.php');

//Register Sidebars
if ( function_exists('register_sidebar') )
register_sidebar(array(
'name' => 'Sidebar',
'description' => 'Widgets in this area will be shown on the right-hand side.',
'before_widget' => '<div class="box">',
'after_widget' => '</div>',
'before_title' => '<h4>',
'after_title' => '</h4>',
));

//Custom Header Settings
define('HEADER_TEXTCOLOR', '');
define('HEADER_IMAGE', '');
define('HEADER_IMAGE_WIDTH', 880);
define('HEADER_IMAGE_HEIGHT', 280);


//Custom Header Style
function admin_header_style() {
    ?><style type="text/css">
        #headimg {
            width: <?php echo HEADER_IMAGE_WIDTH; ?>px;
            height: <?php echo HEADER_IMAGE_HEIGHT; ?>px;
        }
    </style><?php
}
add_custom_image_header('', 'admin_header_style');

// Limit Post Word Count
function new_excerpt_length($length) {
	return 30;
}
add_filter('excerpt_length', 'new_excerpt_length');

//Replace Excerpt Link
function gpp_excerpt($text) { 
	return str_replace('[...]', '...', $text); 
	} 
add_filter('the_excerpt', 'gpp_excerpt');

// Register Navigation Menus
register_nav_menus(
	array(
	'primary'=>__('Top Menu'),
	)
);

// Get Post Categories
$categories = get_categories('hide_empty=0&orderby=name');
$wp_cats = array();
foreach ($categories as $category_list ) {
       $wp_cats[$category_list->cat_ID] = $category_list->cat_name;
}
array_unshift($wp_cats, "Choose a category");



// Start Admin Panel
$themename = "Theme Panel";
$shortname = "xs";


// Theme Options
$options = array (

array( "name" => $themename." Options",
	"type" => "title"),
array( "name" => "Main Options",
	"type" => "section"),
array( "type" => "open"),

array( "name" => "Custom Favicon",
	"desc" => "A favicon is a 16x16 pixel icon that represents your site; paste the URL to a .ico image that you want to use as the image",
	"id" => $shortname."_favicon",
	"type" => "text",
	"std" => get_bloginfo('url') ."/favicon.ico"),
	
array( "name" => "Disable Logo",
	"desc" => "Check this box if you would like to Disable the logo image",
	"id" => $shortname."_disable_logo",
	"type" => "checkbox",
	"std" => "false"),
	
array( "name" => "Custom Logo",
	"desc" => "Insert the URL to your logo here",
	"id" => $shortname."_custom_logo",
	"type" => "text",
	"std" => get_bloginfo('template_url') ."/images/logo.png"),
	
array( "name" => "Disable Main Title",
	"desc" => "Check this box if you would like to Disable the title next to the logo",
	"id" => $shortname."_disable_logo_text",
	"type" => "checkbox",
	"std" => "false"),
	
array( "name" => "Disable Blog Description",
	"desc" => "Check this box if you would like to Disable the blog description next to the main blog title",
	"id" => $shortname."_disable_blog_description",
	"type" => "checkbox",
	"std" => "false"),
	
array( "type" => "close"),
array( "name" => "Navigation Color",
	"type" => "section"),
array( "type" => "open"),

array( "name" => "Choose Navigation Background Color",
	"desc" => "Choose a color scheme for your site - grey is default",
	"id" => $shortname."_color_scheme",
	"type" => "select",
	"options" => array("gray", "blue", "red", "black"),
	"std" => "gray"),
	
array( "type" => "close"),
array( "name" => "Advertisement Banner",
	"type" => "section"),
array( "type" => "open"),

array( "name" => "Disable Header Banner",
	"desc" => "Check this box if you would like to Disable the header advertisement banner.",
	"id" => $shortname."_disable_header_ad",
	"type" => "checkbox",
	"std" => "false"),
	
array( "name" => "Header Ad Image",
	"desc" => "URL to header ad image",
	"id" => $shortname."_header_ad_image",
	"type" => "text",
	"std" => get_bloginfo('template_url') ."/images/banner-sample.gif"),
	
array( "name" => "Header Ad Link",
	"desc" => "Header ad advertisment link",
	"id" => $shortname."_header_ad_url",
	"type" => "text",
	"std" => "http://themeforest.net/?ref=wpexplorer"),
	
array( "type" => "close"),
array( "name" => "Static Homepage Image - Instead Of Slider",
	"type" => "section"),
array( "type" => "open"),

array( "name" => "Enable Static Image For Homepage - Customize at Appearance --> Header",
	"desc" => "Enable static image for homepage instead of header - customize at Appearance -- Header.",
	"id" => $shortname."_enable_static_feature",
	"type" => "checkbox",
	"std" => "false"),

array( "type" => "close"),
array( "name" => "Homepage Featured Slider",
	"type" => "section"),
array( "type" => "open"),

array( "name" => "Disable Homepage Slider",
	"desc" => "Check this box if you would like to Disable the homepage slider.",
	"id" => $shortname."_disable_slider",
	"type" => "checkbox",
	"std" => "false"),

array( "name" => "Featured Category",
	"desc" => "Choose a category from which featured posts are drawn",
	"id" => $shortname."_feat_cat",
	"type" => "select",
	"options" => $wp_cats,
	"std" => "Choose a category"),
	
array( "name" => "How Many Slides",
	"desc" => "Enter how many slides you wish to show on the featured slider.",
	"id" => $shortname."_feat_cat_slides",
	"type" => "text",
	"std" => "3"),

array( "name" => "Pause Time",
	"desc" => "Choose the amount of time in milliseconds between each slide",
	"id" => $shortname."_slider_pause",
	"type" => "text",
	"std" => "3000"),

array( "name" => "Slider Speed",
	"desc" => "Choose the transition speed in milliseconds for your slider",
	"id" => $shortname."_slider_speed",
	"type" => "text",
	"std" => "500"),

array( "name" => "Slider Slices",
	"desc" => "Choose number of slices for the slider animation",
	"id" => $shortname."_slider_slices",
	"type" => "text",
	"std" => "15"),
	
array( "name" => "Animation",
	"desc" => "Choose an animation for your slider",
	"id" => $shortname."_slider_animation",
	"type" => "select",
	"options" => array("fade", "fold", "random", "sliceDown"),
	"std" => "fade"),
	
array( "name" => "Directional Navigation",
	"desc" => "Choose true to enable the directional navigation. Turned on by default",
	"id" => $shortname."_slider_nav",
	"options" => array("true", "false",),
	"std" => "true"),

array( "name" => "Manually Add Items To Your Slider (advanced)",
	"desc" => "Here you can manually add mroe items to your slider. Add them in the same way you would add an image to a website using the HTML img src= tag",
	"id" => $shortname."_manual_slides",
	"type" => "textarea",
	"std" => ""),
	
array( "type" => "close"),
array( "name" => "Portfolio",
	"type" => "section"),
array( "type" => "open"),
	
array( "name" => "Portfolio Category",
	"desc" => "Choose a category for your portfolio page if you have one",
	"id" => $shortname."_portfolio_cat",
	"type" => "select",
	"options" => $wp_cats,
	"std" => "Choose a category"),

array( "name" => "Portfolio Item Count",
	"desc" => "How many items do you want to show on each portfolio page?",
	"id" => $shortname."_portfolio_count",
	"type" => "text",
	"std" => "12"),
	
array( "type" => "close"),
array( "name" => "Thumbnail Images",
	"type" => "section"),
array( "type" => "open"),
	
array( "name" => "Disable Thumbnails On Archieve/Category/Blog pages",
	"desc" => "Check this box if you would like to disable the thumbnail images on archieve/category pages.",
	"id" => $shortname."_disable_thumbnails_archieve",
	"type" => "checkbox",
	"std" => "false"),
	
array( "name" => "Disable Thumbnails On Blog Posts",
	"desc" => "Check this box if you would like to disable the thumbnail images on your blog posts.",
	"id" => $shortname."_disable_thumbnails_posts",
	"type" => "checkbox",
	"std" => "false"),
	
array( "name" => "Thumbnail Width",
	"desc" => "Type a width in pixels for post pages, blog page & category Page.",
	"id" => $shortname."_thumbnail_height",
	"type" => "text",
	"std" => "120"),
	
array( "name" => "Thumbnail Height",
	"desc" => "Type a width in pixels for post pages, blog page & category Page.",
	"id" => $shortname."_thumbnail_width",
	"type" => "text",
	"std" => "120"),

array( "type" => "close"),
array( "name" => "Analytics",
	"type" => "section"),
array( "type" => "open"),

array( "name" => "Google Analytics Code",
	"desc" => "You can paste your Google Analytics or other tracking code in this box. This will be automatically added to the footer.",
	"id" => $shortname."_ga_code",
	"type" => "textarea",
	"std" => ""),
	
array( "type" => "close")

);

// Define Admin Panel

function mytheme_add_admin() {

global $themename, $shortname, $options;

if ( $_GET['page'] == basename(__FILE__) ) {

	if ( 'save' == $_REQUEST['action'] ) {

		foreach ($options as $value) {
		update_option( $value['id'], $_REQUEST[ $value['id'] ] ); }

foreach ($options as $value) {
	if( isset( $_REQUEST[ $value['id'] ] ) ) { update_option( $value['id'], $_REQUEST[ $value['id'] ]  ); } else { delete_option( $value['id'] ); } }

	header("Location: admin.php?page=functions.php&saved=true");
die;

}
else if( 'reset' == $_REQUEST['action'] ) {

	foreach ($options as $value) {
		delete_option( $value['id'] ); }

	header("Location: admin.php?page=functions.php&reset=true");
die;

}
}

add_menu_page($themename, $themename, 'administrator', basename(__FILE__), 'mytheme_admin');
}

function mytheme_add_init() {
$file_dir=get_bloginfo('template_directory');
wp_enqueue_style("functions", $file_dir."/functions/xspanel.css", false, "1.0", "all");
wp_enqueue_script("rm_script", $file_dir."/js/rm_script.js", false, "1.0");

}
function mytheme_admin() {

global $themename, $shortname, $options;
$i=0;

if ( $_REQUEST['saved'] ) echo '<div id="message" class="updated fade"><p><strong>'.$themename.' settings saved.</strong></p></div>';
if ( $_REQUEST['reset'] ) echo '<div id="message" class="updated fade"><p><strong>'.$themename.' settings reset.</strong></p></div>';

?>
<div class="wrap rm_wrap">
<h2><?php echo $themename; ?> Settings</h2>

<div class="rm_opts">
<form method="post">
<?php foreach ($options as $value) {
switch ( $value['type'] ) {

case "open":
?>

<?php break;

case "close":
?>

</div>
</div>
<br />

<?php break;

case "title":
?>
<h3>Advertisement</h3>
Get the best deal in WordPress themes at the following site:
<a href="http://www.wpexplorer.com/elegant-themes-membership" title="Elegant Themes" target="_blank"><img src="http://www.wpexplorer.com/images/elegant-banner.gif" alt="Elegant Themes" height="60" width="468"></a>
<h3>Theme Options</h3>
<?php break;

case 'text':
?>

<div class="rm_input rm_text">
	<label for="<?php echo $value['id']; ?>"><?php echo $value['name']; ?></label>
 	<input name="<?php echo $value['id']; ?>" id="<?php echo $value['id']; ?>" type="<?php echo $value['type']; ?>" value="<?php if ( get_settings( $value['id'] ) != "") { echo stripslashes(get_settings( $value['id'])  ); } else { echo $value['std']; } ?>" />
 <small><?php echo $value['desc']; ?></small><div class="clearfix"></div>

 </div>
<?php
break;

case 'textarea':
?>

<div class="rm_input rm_textarea">
	<label for="<?php echo $value['id']; ?>"><?php echo $value['name']; ?></label>
 	<textarea name="<?php echo $value['id']; ?>" type="<?php echo $value['type']; ?>" cols="" rows=""><?php if ( get_settings( $value['id'] ) != "") { echo stripslashes(get_settings( $value['id']) ); } else { echo $value['std']; } ?></textarea>
 <small><?php echo $value['desc']; ?></small><div class="clearfix"></div>

 </div>

<?php
break;

case 'select':
?>

<div class="rm_input rm_select">
	<label for="<?php echo $value['id']; ?>"><?php echo $value['name']; ?></label>

<select name="<?php echo $value['id']; ?>" id="<?php echo $value['id']; ?>">
<?php foreach ($value['options'] as $option) { ?>
		<option <?php if (get_settings( $value['id'] ) == $option) { echo 'selected="selected"'; } ?>><?php echo $option; ?></option><?php } ?>
</select>

	<small><?php echo $value['desc']; ?></small><div class="clearfix"></div>
</div>
<?php
break;

case "checkbox":
?>

<div class="rm_input rm_checkbox">
	<label for="<?php echo $value['id']; ?>"><?php echo $value['name']; ?></label>

<?php if(get_option($value['id'])){ $checked = "checked=\"checked\""; }else{ $checked = "";} ?>
<input type="checkbox" name="<?php echo $value['id']; ?>" id="<?php echo $value['id']; ?>" value="true" <?php echo $checked; ?> />

	<small><?php echo $value['desc']; ?></small><div class="clearfix"></div>
 </div>
<?php break;
case "section":

$i++;

?>

<div class="rm_section">
<div class="rm_title"><h3><img src="<?php bloginfo('template_directory')?>/functions/images/trans.png" class="inactive" alt="""><?php echo $value['name']; ?></h3><span class="submit"><input name="save<?php echo $i; ?>" type="submit" value="Save changes" />
</span><div class="clearfix"></div></div>
<div class="rm_options">

<?php break;

}
}
?>

<input type="hidden" name="action" value="save" />
</form>
<form method="post">
<p class="submit">
<input name="reset" type="submit" value="Reset" />
<input type="hidden" name="action" value="reset" />
</p>
</form>
<div>
<h2>Get More Themes &amp; Templates - AJ's Websites</h2>
<p><a href="http://www.wpexplorer.com/" title="Wordpress Themes">Wordpress Themes</a><br />
  <a href="http://www.psdexplorer.com/">PSD Templates</a><br />
  <a href="http://www.templatexplorer.com/">HTML Templates </a></p>
<div style="font-size:9px; margin-bottom:10px;">Xpert Panel Icons Provided by: <a href="http://www.woothemes.com/2009/09/woofunction/" target="_blank">WooFunction</a></div>
 </div> 

<?php
}

?>
<?php
add_action('admin_init', 'mytheme_add_init');
add_action('admin_menu', 'mytheme_add_admin');
?>